<#assign extendsClass>MapServiceBase</#assign>
<#ibizinclude>
../@MACRO/SERVICE/SERVICE_HEADER.ts.ftl
</#ibizinclude>
    /**
     * 地图项配置集合
     *
     * @protected
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected mapItemConfig: any = {
<#if ctrl.getPSSysMapItems?? && ctrl.getPSSysMapItems()??>
    <#list ctrl.getPSSysMapItems() as mapItem>
        <#if mapItem.getPSAppDataEntity()?? && mapItem.getPSDEDataSet()??>
        '${mapItem.getItemType()?lower_case}': {
            itemName : '${mapItem.getName()}',
            itemType : '${mapItem.getItemType()?lower_case}',
        },
        </#if>
    </#list>
</#if>
    };

    /**
     * 查询数据
     *
     * @param {string} itemType
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isLoading]
     * @returns {Promise<HttpResponse>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    public async search(itemType: string, context: any = {}, data: any = {}, isLoading?: boolean): Promise<HttpResponse> {
        let item: any = {};
        try {
<#if ctrl.getPSSysMapItems()??>
    <#list ctrl.getPSSysMapItems() as mapItem>
        <#if mapItem.getPSAppDataEntity()?? && mapItem.getPSDEDataSet()??>

            <#assign _appde = mapItem.getPSAppDataEntity() />
            <#assign deDataSet = mapItem.getPSDEDataSet() />
            this.model.itemType = '${mapItem.getItemType()?lower_case}';
            const _${mapItem.getItemType()?lower_case}_data = this.handleRequestData('', context, data);
            await this.onBeforeAction('', context, _${mapItem.getItemType()?lower_case}_data, isLoading);
                <#if _appde.getId() == appde.getId()>
            const _${mapItem.getItemType()?lower_case} = await this.loadDEDataSet('Fetch${deDataSet.getCodeName()}', context, _${mapItem.getItemType()?lower_case}_data, '${mapItem.getItemType()?lower_case}');
                <#else>
            const _${mapItem.getItemType()?lower_case} = await this.loadDEDataSet('Fetch${deDataSet.getCodeName()}', context, _${mapItem.getItemType()?lower_case}_data, '${mapItem.getItemType()?lower_case}', '${_appde.getCodeName()?lower_case}');
                </#if>
            Object.assign(item, { ${mapItem.getItemType()?lower_case}: _${mapItem.getItemType()?lower_case} });
        </#if>
    </#list>
</#if>
        } catch (response) {
            return new HttpResponse(response.status);
        }
        return new HttpResponse(200, item);
    }

<#ibizinclude>
../@MACRO/SERVICE/SERVICE_BOTTOM.ts.ftl
</#ibizinclude>